- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# TF_VerifierBase Class Reference

`#include <pubkey.h>`

Inheritance diagram for TF_VerifierBase:

List of all members.

## Detailed Description

_

Definition at line 343 of file pubkey.h.

## Public Member Functions
void | InputSignature (PK_MessageAccumulator &messageAccumulator, const byte *signature, size_t signatureLength) const
| input signature into a message accumulator
bool | VerifyAndRestart (PK_MessageAccumulator &messageAccumulator) const
| check whether messageAccumulator contains a valid signature and message, and restart messageAccumulator
DecodingResult | RecoverAndRestart (byte *recoveredMessage, PK_MessageAccumulator &recoveryAccumulator) const
| recover a message from its signature
size_t | SignatureLength () const
| signature length if it only depends on the key, otherwise 0
size_t | MaxRecoverableLength () const
| length of longest message that can be recovered, or 0 if this signature scheme does not support message recovery
size_t | MaxRecoverableLengthFromSignatureLength (size_t signatureLength) const
| length of longest message that can be recovered from a signature of given length, or 0 if this signature scheme does not support message recovery
bool | IsProbabilistic () const
| requires a random number generator to sign
bool | AllowNonrecoverablePart () const
| whether or not a non-recoverable message part can be signed
bool | RecoverablePartFirst () const
| whether you must input the recoverable part before the non-recoverable part during signing
virtual PK_MessageAccumulator * | NewVerificationAccumulator () const=0
| create a new HashTransformation to accumulate the message to be verified
virtual bool | Verify (PK_MessageAccumulator *messageAccumulator) const
| check whether messageAccumulator contains a valid signature and message, and delete messageAccumulator (even in case of exception thrown)
virtual bool | VerifyMessage (const byte *message, size_t messageLen, const byte *signature, size_t signatureLength) const
| check whether input signature is a valid signature for input message
virtual DecodingResult | Recover (byte *recoveredMessage, PK_MessageAccumulator *messageAccumulator) const
| recover a message from its signature
virtual DecodingResult | RecoverMessage (byte *recoveredMessage, const byte *nonrecoverableMessage, size_t nonrecoverableMessageLength, const byte *signature, size_t signatureLength) const
| recover a message from its signature
virtual size_t | MaxSignatureLength (size_t recoverablePartLength=0) const
| maximum signature length produced for a given length of recoverable message part
virtual bool | SignatureUpfront () const
| if this function returns true, during verification you must input the signature before the message, otherwise you can input it at anytime */
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual PublicKey & | AccessPublicKey ()=0
virtual const PublicKey & | GetPublicKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Protected Types
typedef TrapdoorFunction | TrapdoorFunctionInterface
typedef PK_SignatureMessageEncodingMethod | MessageEncodingInterface
## Protected Member Functions
size_t | MessageRepresentativeLength () const
size_t | MessageRepresentativeBitLength () const
virtual HashIdentifier | GetHashIdentifier () const=0
virtual size_t | GetDigestSize () const=0
virtual const TrapdoorFunctionBounds & | GetTrapdoorFunctionBounds () const=0
virtual const TrapdoorFunctionInterface & | GetTrapdoorFunctionInterface () const=0
virtual const MessageEncodingInterface & | GetMessageEncodingInterface () const=0

## Member Function Documentation

DecodingResult TF_VerifierBase::RecoverAndRestart | ( | byte * | recoveredMessage,
|  | PK_MessageAccumulator & | recoveryAccumulator |
| ) |  |  | const`[virtual]`

recover a message from its signature

Precondition:
  size of recoveredMessage == MaxRecoverableLengthFromSignatureLength(signatureLength)

Implements PK_Verifier.

Definition at line 120 of file pubkey.cpp.

References PK_MessageAccumulatorBase::AccessHash(), HashTransformation::DigestSize(), PK_MessageAccumulatorBase::m_empty, PK_MessageAccumulatorBase::m_representative, TF_SignatureSchemeBase< PK_Verifier, TF_Base< TrapdoorFunction, PK_SignatureMessageEncodingMethod > >::MessageRepresentativeBitLength(), PK_SignatureMessageEncodingMethod::MinRepresentativeBitLength(), and PK_SignatureMessageEncodingMethod::RecoverMessageFromRepresentative().

bool TF_SignatureSchemeBase< PK_Verifier , TF_Base< TrapdoorFunction, PK_SignatureMessageEncodingMethod > >::IsProbabilistic | ( |  | ) | const`[inline, virtual, inherited]`

Implements PK_SignatureScheme.

Definition at line 320 of file pubkey.h.

DecodingResult PK_Verifier::Recover | ( | byte * | recoveredMessage,
|  | PK_MessageAccumulator * | messageAccumulator |
| ) |  |  | const`[virtual, inherited]`

recover a message from its signature

Precondition:
  size of recoveredMessage == MaxRecoverableLengthFromSignatureLength(signatureLength)

Definition at line 653 of file cryptlib.cpp.

References PK_Verifier::RecoverAndRestart().

DecodingResult PK_Verifier::RecoverMessage | ( | byte * | recoveredMessage,
|  | const byte * | nonrecoverableMessage,
|  | size_t | nonrecoverableMessageLength,
|  | const byte * | signature,
|  | size_t | signatureLength |
| ) |  |  | const`[virtual, inherited]`

recover a message from its signature

Precondition:
  size of recoveredMessage == MaxRecoverableLengthFromSignatureLength(signatureLength)

Definition at line 659 of file cryptlib.cpp.

References PK_Verifier::InputSignature(), PK_Verifier::NewVerificationAccumulator(), and PK_Verifier::RecoverAndRestart().

The documentation for this class was generated from the following files:

- pubkey.h
- pubkey.cpp